// ***************************************************************************
// File:        PipeServer.h 
// Copyright:   (c) 2010 by Frydaysoft.de
// Author:      SFr (frydaysoft@gmx.de)
// Proj:        light visualization plugin (winamp)
// Short Info:  named pipe server application
// ***************************************************************************


// ***************************************************************************
#ifndef LINE_LEN
  #define LINE_LEN  80
#endif
#define MSG_SIZE  9

// ***************************************************************************
// Buffers and pipe constants.
#define IN_BUF_SIZE        2*MSG_SIZE
#define OUT_BUF_SIZE       0
#define TIME_OUT           0

// ***************************************************************************
// Stringtable identifiers
#define	IDS_WRONGOS     100
#define IDS_WINDOWTITLE 101
#define IDS_ERRORCODE   102
#define IDS_DEBUGTITLE  103
#define IDS_READERROR   104
#define IDS_DEBUGINFO   105
#define IDS_DEBUGLAST   106

//*************************************************************************
typedef struct
{
  USHORT  VendorID;
  USHORT  ProductID;
  BOOL    TestStrings;
  LPWSTR  ManufacturerStr;
  LPWSTR  ProductStr;
}T_sSeekOpt;


// ***************************************************************************
// Structure used to hold information about a pipe client.
typedef struct 
{ 
  HANDLE      hPipe;
  BOOL        live;
  CHAR        Msg[MSG_SIZE];
  BYTE        Lights_0;
  BYTE        Lights_1;
  T_sSeekOpt  *pSeekOpt;
  HANDLE      usbHandle;

  HWND     hWnd;
  HANDLE   hInst;
  CHAR     lpBuffer[255];
  HBRUSH   brushBk;
  HBRUSH   brushLamp;
  HPEN     hpen;
} PIPE_HANDLE;


// ***************************************************************************
LONG CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);
VOID ThreadProc(HWND *);
VOID TellMsg(CHAR *);
VOID DrawView(HDC, RECT *);
